/* <LIC_AMD_STD>
 * Copyright (c) 2004-2005 Advanced Micro Devices, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * The full GNU General Public License is included in this distribution in the
 * file called COPYING
 * </LIC_AMD_STD>  */
/* <CTL_AMD_STD>
 * </CTL_AMD_STD>  */
/* <DOC_AMD_STD>
 * </DOC_AMD_STD>  */

#ifndef CS5535_H
#define CS5535_H

#include <linux/config.h>
#include <linux/pci.h>
#include <linux/ide.h>

#define DISPLAY_CS5535_TIMINGS

#define MSR_ATAC_BASE    0x51300000
#define ATAC_GLD_MSR_CAP (MSR_ATAC_BASE+0)
#define ATAC_GLD_MSR_CONFIG    (MSR_ATAC_BASE+0x01)
#define ATAC_GLD_MSR_SMI       (MSR_ATAC_BASE+0x02)
#define ATAC_GLD_MSR_ERROR     (MSR_ATAC_BASE+0x03)
#define ATAC_GLD_MSR_PM        (MSR_ATAC_BASE+0x04)
#define ATAC_GLD_MSR_DIAG      (MSR_ATAC_BASE+0x05)
#define ATAC_IO_BAR            (MSR_ATAC_BASE+0x08)
#define ATAC_RESET             (MSR_ATAC_BASE+0x10)
#define ATAC_CH0D0_PIO         (MSR_ATAC_BASE+0x20)
#define ATAC_CH0D0_DMA         (MSR_ATAC_BASE+0x21)
#define ATAC_CH0D1_PIO         (MSR_ATAC_BASE+0x22)
#define ATAC_CH0D1_DMA         (MSR_ATAC_BASE+0x23) 
#define ATAC_PCI_ABRTERR       (MSR_ATAC_BASE+0x24)
#define ATAC_BM0_CMD_PRIM      0x00
#define ATAC_BM0_STS_PRIM      0x02
#define ATAC_BM0_PRD           0x04

#define CS5535_CABLE_DETECT    0x48

#if defined(DISPLAY_CS5535_TIMINGS) && defined(CONFIG_PROC_FS)
#include <linux/stat.h>
#include <linux/proc_fs.h>

static u8 cs5535_proc;

static int cs5535_get_info(char *, char **, off_t, int);

static ide_pci_host_proc_t cs5535_procs[] __initdata = {
	{
		.name		= "cs5535",
		.set		= 1,
		.get_info	= cs5535_get_info,
		.parent		= NULL,
	},
};

#endif /* DISPLAY_CS5530_TIMINGS && CONFIG_PROC_FS */

static unsigned int init_chipset_cs5535(struct pci_dev *, const char *);
static void init_hwif_cs5535(ide_hwif_t *);

static ide_pci_device_t cs5535_chipsets[] __devinitdata = {
	{	/* 0 */
		.vendor		= PCI_VENDOR_ID_NS,
		.device		= PCI_DEVICE_ID_NS_CS5535_IDE,
		.name		= "CS5535",
		.init_chipset	= init_chipset_cs5535,
		.init_iops	= NULL,
		.init_hwif	= init_hwif_cs5535,
		.channels	= 1,
		.autodma	= AUTODMA,
		.enablebits	= { {0x00,0x00,0x00} },  
		.bootable	= ON_BOARD,
		.extra		= 0,
	},{	/* 1 */
		.vendor		= PCI_VENDOR_ID_AMD,
		.device		= PCI_DEVICE_ID_AMD_CS5536_IDE,
		.name		= "CS5536",
		.init_chipset	= init_chipset_cs5535,
		.init_iops	= NULL,
		.init_hwif	= init_hwif_cs5535,
		.channels	= 1,
		.autodma	= AUTODMA,
		.enablebits	= { {0x00,0x00,0x00} },  
		.bootable	= ON_BOARD,
		.extra		= 0,
	},{
		.vendor		= 0,
		.device		= 0,
		.channels	= 0,
		.bootable	= EOL,
	}
};

#endif /* CS5535_H */
